draw_th0:
  xor eax,eax
  call draw_thread
  invoke SendMessage,hwnd,WM_FINISH,0,0
  invoke ExitThread,0
ret

draw_th1:
  mov eax,1
  call draw_thread
  invoke SendMessage,hwnd,WM_FINISH,0,0
  invoke ExitThread,1
ret
draw_thread:
    push   ebp
    mov    ebp,esp
    sub    esp,256
    and    ebp,-16

    .thread_no equ dword[ebp-4]
    .x_min     equ word[ebp-6]
    .x_max     equ word[ebp-8]
    .y_min     equ word[ebp-10]
    .y_max     equ [ebp-12]
    .third_p_index  equ dword[ebp-16]
    .second_p_index equ dword[ebp-20]
    .first_p_index  equ dword[ebp-24]
    .zz3f equ dword[ebp-28]
    .zz2f equ dword[ebp-32]
    .zz1f equ [ebp-36]
    .next_chunk_ptr equ [ebp-40]
 ;   .mark	     equ [ebp-44]
    .mark_tri	    equ [ebp-48]
    .col	    equ [ebp-52]



    movzx  ebx,[yres_var]
    shr    ebx,1   ; shr ebx,n ;n=1 - 2 threads, n=2 - 4 threads...
    mov    ecx,ebx
    imul   ebx,eax
    mov    .y_min,bx
    add    ebx,ecx
    mov    .y_max,bx
    mov    .x_min,0
    push   word[xres_var]
    pop    .x_max
    push   dword tri_chunks_desc
    pop    dword .next_chunk_ptr

;    mov   esi,triangles	    ; draw triangles
;    movzx ecx,[triangles_count_var]
.next_chunk:   ; next sort of triangles
    mov   eax,.next_chunk_ptr
    cmp   dword[eax],0xcccccccc
    jne   .the_end
    mov   ebx,eax
    add   ebx,[eax+4]
    mov   .next_chunk_ptr,ebx
    push  dword[eax+8]
    pop   dword .mark_tri
    mov   ecx,dword[eax+12]   ;triangles count
    mov   esi,[eax+16]
    add   esi,triangles
    push  dword[eax+20]
    pop   dword .col
    mov   .next_chunk_ptr,ebx


.draw_triangle:
    push  ecx
    push  esi
    cmp   dword .mark_tri,0
    jne   .glass

    movzx edx,word[esi]
    shl   edx,2
    lea   edx,[edx*3]
    mov   .first_p_index,edx
    add   edx,points_rotated
    movlps	xmm0,[edx]
    cvtps2dq	xmm0,xmm0
    packssdw	xmm0,xmm0
    movd	eax,xmm0
    ror 	eax,16	;proteza
    push	dword[edx+8]
    pop 	dword .zz1f

    movzx      edx,word[esi+2]
    shl        edx,2
    lea        edx,[edx*3]
    mov        .second_p_index,edx
    add        edx,points_rotated
    movlps     xmm0,[edx]
    cvtps2dq   xmm0,xmm0
    packssdw  xmm0,xmm0
    movd       ebx,xmm0
    ror        ebx,16
    push       dword[edx+8]
    pop        .zz2f
    movzx edx,word[esi+4]
    shl   edx,2
    lea   edx,[edx*3]
    mov   .third_p_index,edx
    add   edx,points_rotated
    movlps	xmm0,[edx]
    cvtps2dq	xmm0,xmm0
    packssdw	xmm0,xmm0
    movd	ecx,xmm0
    ror 	ecx,16
    push	dword[edx+8]
    pop 	.zz3f


     mov     edx,.first_p_index
     mov     esi,.second_p_index
     mov     edi,.third_p_index
     movups  xmm0,[edx+points_normals_rotated]
     movups  xmm1,[esi+points_normals_rotated]
     movups  xmm2,[edi+points_normals_rotated]
     andps   xmm0,[mask_h_zero]
     andps   xmm1,[mask_h_zero]
     andps   xmm2,[mask_h_zero]
     mov     edx,1.0
     movd    xmm3,edx
     pshufd  xmm3,xmm3,11001111b
     movups  xmm4,.zz1f
     andps   xmm4,[mask_h_zero]
     xorps   xmm6,xmm6
     movq    xmm5,.y_max
     punpcklwd xmm5,xmm6
; is	  lo -> hi     ymax, ymin, xmax, xmin
; will be lo -> hi     ymin, ymax, xmin, xmax
     pshufd  xmm5,xmm5,10110001b

     mov     edi,[screen_ptr]	; screen buffer
     mov     esi,[Zbuffer_ptr]
  ;   mov     edx,texmap
     movd    mm0,.col
     movd    mm1,[stencil_buffer_ptr]

     call    real_phong_tri_col_stencil
     jmp     .end_draw

  .glass:
    movzx edx,word[esi]
    shl   edx,2
    lea   edx,[edx*3]
    mov   .first_p_index,edx
    add   edx,points_rotated
    movlps	xmm0,[edx]
    cvtps2dq	xmm0,xmm0
    packssdw	xmm0,xmm0
    movd	eax,xmm0
    ror 	eax,16	;proteza
    push	dword[edx+8]
    pop 	dword .zz1f

    movzx      edx,word[esi+2]
    shl        edx,2
    lea        edx,[edx*3]
    mov        .second_p_index,edx
    add        edx,points_rotated
    movlps     xmm0,[edx]
    cvtps2dq   xmm0,xmm0
    packssdw  xmm0,xmm0
    movd       ebx,xmm0
    ror        ebx,16
    push       dword[edx+8]
    pop        .zz2f
    movzx edx,word[esi+4]
    shl   edx,2
    lea   edx,[edx*3]
    mov   .third_p_index,edx
    add   edx,points_rotated
    movlps	xmm0,[edx]
    cvtps2dq	xmm0,xmm0
    packssdw	xmm0,xmm0
    movd	ecx,xmm0
    ror 	ecx,16
    push	dword[edx+8]
    pop 	.zz3f


     mov     edx,.first_p_index
     mov     esi,.second_p_index
     mov     edi,.third_p_index
     movups  xmm0,[edx+points_normals_rotated]
     movups  xmm1,[esi+points_normals_rotated]
     movups  xmm2,[edi+points_normals_rotated]
     andps   xmm0,[mask_h_zero]
     andps   xmm1,[mask_h_zero]
     andps   xmm2,[mask_h_zero]
     mov     edx,1.0
     movd    xmm3,edx
     pshufd  xmm3,xmm3,11001111b
     movups  xmm4,.zz1f
     andps   xmm4,[mask_h_zero]
     xorps   xmm6,xmm6
     movq    xmm5,.y_max
     punpcklwd xmm5,xmm6
; is	  lo -> hi     ymax, ymin, xmax, xmin
; will be lo -> hi     ymin, ymax, xmin, xmax
     pshufd  xmm5,xmm5,10110001b
 ;    mov     edx, 0 shl 16 + 64
 ;    mov     esi,127 shl 16 + 127
 ;    mov     edi,127 shl 16 + 0
 ;    movd    xmm6,edx
 ;    movd    xmm7,esi
 ;    movlhps xmm6,xmm7
 ;    movd    xmm7,edi
 ;    pslldq  xmm7,4
 ;    por     xmm6,xmm7
 ;    movzx   edx,word[xres_var]
 ;    movd    xmm7,edx
 ;    pslldq  xmm7,12
 ;    por     xmm6,xmm7

     mov     edi,[screen_ptr]	; screen buffer
     mov     edx,[stencil_buffer_ptr]
  ;   mov     edx,texmap
   ;  movd    mm0,.col
     movd    mm0,[Zbuffer_ptr]

     call    glass_tri_stencil_z

 .end_draw:
    pop    esi
    pop    ecx
    add    esi,6
    sub    ecx,1
    jnz    .draw_triangle
    mov   eax,.next_chunk_ptr
    cmp   dword[eax],0
    jne   .next_chunk
 .the_end:
    add esp,256
    pop ebp
ret
